//////////////////////////////////////////////////////////////////////

void clearCache()
// Tout le cache est rempli de zéros
{
  for (int i=0; i<sizeBuffer; i++) {
    bufferMem[i] = 0;
  }
}

////////

void clearCache(int numCache)
// La zone du cache indiquée est remplie de zéros
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache,xGlobal,yGlobal);
  for (int i=0; i<8; i++) {
    for (int j=0; j<8; j++) {
      bufferMem[indice(xGlobal+i,yGlobal+j)] = 0;
    }
  }
}

//////////////////////////////////////////////////////////////////////

void setPixelCache(int xGlobal, int yGlobal, boolean state)
// Enregistre l'état d'un pixel dans le cache
{
  bufferMem[indice(xGlobal,yGlobal)] = state;
}

////////

void setPixelCache(int numCache, int xLocal, int yLocal, boolean state)
// Enregistre l'état d'un pixel dans le cache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  int offset = indice(xGlobal,yGlobal);
  bufferMem[offset + indice(xLocal,yLocal)] = state;
}

//////////////////////////////////////////////////////////////////////

void printCache(int numCache)
// Affiche une zone du cache (chaque zone contient 8x8 = 64 bits)
// [0] [1] [2]
// [3] [4] [5]
// [6] [7] [8]
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  int offset = indice(xGlobal,yGlobal);
  byte data = 0;
  for (int j=0; j<=7; j++) { // Balayage des colonnes
    for (int i=0; i<=7; i++) { // Balayage des lignes
      data = data << 1;
      data = data + bufferMem[offset + indice(j,i)];
    }
    byte adresse = j + 1;
    writeMAX7219(adresse,data);
  }
}

//////////////////////////////////////////////////////////////////////

void affecterCoordonneesZoneCache (int numCache, int& x, int& y)
// Convertit une zone du cache en coordonnées (x;y)
// Passage par référence : La modification de la variable affecte également la valeur de la variable en dehors de la fonction
{
  x = 8 * (numCache%numX);
  y = 8 * (numCache/numX);
}

//////////////////////////////////////////////////////////////////////
