//////////////////////////////////////////////////////////////////////

void shiftCharLeft(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharLeft(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharLeft(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 0;
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal - nbSteps;
    if (xEnd < 0) {
      xEnd = 0;
    }
  }
  for (int i=xGlobal; i>=xEnd; i--) {
    printChar(numChar,i,yGlobal);
    delay(delayTime);
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharRight(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharRight(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharRight(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 8 * (numX-1);
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal + nbSteps;
    if (xEnd > 8 * (numX-1)) {
      xEnd = 8 * (numX-1);
    }
  }
  for (int i=xGlobal; i<=xEnd; i++) {
    printChar(numChar,i,yGlobal);
    delay(delayTime);
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharUp(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers le haut avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharUp(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharUp(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers le haut avec comme position de départ (xGlobal;yGlobal)
{
  int yEnd = 0;
  if (nbSteps != MAXI_STEPS) {
    yEnd = yGlobal - nbSteps;
    if (yEnd < 0) {
      yEnd = 0;
    }
  }
  for (int j=yGlobal; j>=yEnd; j--) {
    printChar(numChar,xGlobal,j);
    delay(delayTime);
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharDown(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers le haut avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharDown(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharDown(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers le haut avec comme position de départ (xGlobal;yGlobal)
{
  int yEnd = 8 * (numY-1);
  if (nbSteps != MAXI_STEPS) {
    yEnd = yGlobal + nbSteps;
    if (yEnd > 8 * (numY-1)) {
      yEnd = 8 * (numY-1);
    }
  }
  for (int j=yGlobal; j<=yEnd; j++) {
    printChar(numChar,xGlobal,j);
    delay(delayTime);
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharLeftUp(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche et le haut avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharLeftUp(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharLeftUp(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche et le haut avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 0;
  int yEnd = 0;
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal - nbSteps;
    if (xEnd < 0) {
      xEnd = 0;
    }
    yEnd = yGlobal - nbSteps;
    if (yEnd < 0) {
      yEnd = 0;
    }
  }
  int i = xGlobal;
  int j = yGlobal;
  while (i>=xEnd && j>=yEnd)
  {
    printChar(numChar,i,j);
    delay(delayTime);
    i--;
    j--;  
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharRightUp(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite et le haut avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharRightUp(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharRightUp(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite et le haut avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 8 * (numX-1);
  int yEnd = 0;
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal + nbSteps;
    if (xEnd > 8 * (numX-1)) {
      xEnd = 8 * (numX-1);
    }
    yEnd = yGlobal - nbSteps;
    if (yEnd < 0) {
      yEnd = 0;
    }
  }
  int i = xGlobal;
  int j = yGlobal;
  while (i<=xEnd && j>=yEnd)
  {
    printChar(numChar,i,j);
    delay(delayTime);
    i++;
    j--;  
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharLeftDown(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche et le bas avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharLeftDown(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharLeftDown(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la gauche et le bas avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 0;
  int yEnd = 8 * (numY-1);
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal - nbSteps;
    if (xEnd < 0) {
      xEnd = 0;
    }
    yEnd = yGlobal + nbSteps;
    if (yEnd > 8 * (numY-1)) {
      yEnd = 8 * (numY-1);
    }
  }
  int i = xGlobal;
  int j = yGlobal;
  while (i>=xEnd & j<=yEnd)
  {
    printChar(numChar,i,j);
    delay(delayTime);
    i--;
    j++;  
  }
}

//////////////////////////////////////////////////////////////////////

void shiftCharRightDown(byte numChar, int numCache, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite et le bas avec comme position de départ numCache
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  shiftCharRightDown(numChar, xGlobal, yGlobal, nbSteps, delayTime);
}

////////

void shiftCharRightDown(byte numChar, int xGlobal, int yGlobal, int nbSteps, int delayTime)
// Décalage du caractère numChar vers la droite et le bas avec comme position de départ (xGlobal;yGlobal)
{
  int xEnd = 8 * (numX-1);
  int yEnd = 8 * (numY-1);
  if (nbSteps != MAXI_STEPS) {
    xEnd = xGlobal + nbSteps;
    if (xEnd > 8 * (numX-1)) {
      xEnd = 8 * (numX-1);
    }
    yEnd = yGlobal + nbSteps;
    if (yEnd > 8 * (numY-1)) {
      yEnd = 8 * (numY-1);
    }
  }
  int i = xGlobal;
  int j = yGlobal;
  while (i<=xEnd && j<=yEnd)
  {
    printChar(numChar,i,j);
    delay(delayTime);
    i++;
    j++;  
  }
}

//////////////////////////////////////////////////////////////////////






//////////////////////////////////////////////////////////////////////

void scrollText(String text, int numCache, int delayTime)
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  scrollText(text, xGlobal, yGlobal, delayTime);
}

////////

void scrollText(String text, int xGlobal, int yGlobal, int delayTime)
{
  clearCache(FENETRE);
  text = " " + text;
  int sizeText = text.length();
  for (int i=0; i<sizeText; i++) {
    for(int j=0; j<=5; j++) {  // Largeur d'un caractère = 5 pixels
      char car = text[i];
      setCharCache(car-32,xGlobal-j,yGlobal);
      if (i < sizeText-1) {
        car = text[i+1];
        setCharCache(car-32,xGlobal+6-j,yGlobal);  // 6 = 5 pixels + 1 espace
      }
    rognerFenetre();
    printCache(FENETRE);
    delay(delayTime);
    }
  }
}

//////////////////////////////////////////////////////////////////////






//////////////////////////////////////////////////////////////////////

void printChar(byte numChar, int xGlobal, int yGlobal)
// Ecrit le caractère numChar aux coordonnées (xGlobal;yGlobal) du cache
{
  if ((xGlobal <= 8*(numX-1)) and (yGlobal <= 8*(numY-1)))
  {
    //clearCache(FENETRE);
    setCharCache(numChar-32,xGlobal,yGlobal);  // Les 32 premiers codes ASCII ne sont pas des caractères affichables
    rognerFenetre();
    printCache(FENETRE);
  }
}

//////////////////////////////////////////////////////////////////////

void setCharCache(byte numChar, int numCache)
{
  int xGlobal;
  int yGlobal;
  affecterCoordonneesZoneCache(numCache, xGlobal, yGlobal);
  setCharCache(numChar, xGlobal, yGlobal);
}

////////

void setCharCache(byte numChar, int xGlobal, int yGlobal)
// Utilise la table de caractère table.h
{
  int offset = indice(xGlobal, yGlobal);
  byte data = 0;
  for (int i=0; i<=7; i++) { // Balayage des lignes
    data = (CHAR_TABLE [numChar] >> i * 8) & 0xFF;
    //Serial.println(data,HEX);
    for (int j=7; j>=0; j--) { // Balayage des colonnes
      bufferMem[offset + indice(j,i)] = data >> 7;
      data = data << 1;
    }
  }
}

/////////////////////////////////////////////////////////////////////

void rognerFenetre()
// La fenêtre de visualisation (initialement 8x8) est rognée pour l'adapter à la taille des caractères (5x7)
// 00000000
// 0     00
// 0     00
// 0     00
// 0     00
// 0     00
// 0     00
// 0     00
{
    int xGlobal;
    int yGlobal;
    affecterCoordonneesZoneCache(FENETRE,xGlobal,yGlobal);
    for (int i=xGlobal; i<=xGlobal+8; i++) {
      setPixelCache(i,yGlobal,0);
    }
    for (int j=yGlobal; j<=yGlobal+8; j++) {
      setPixelCache(xGlobal+0,j,0);
      setPixelCache(xGlobal+6,j,0);
      setPixelCache(xGlobal+7,j,0);
    }
}

//////////////////////////////////////////////////////////////////////
